<?php
function getFieldLabel_FirewallHelper($field, array $fieldRules, array $attributes = array()): string
{
  switch ($field) {
    default:
      if (strpos($fieldRules[$field], 'required') !== false) {
        array_push($attributes, 'style="color:red";');
      }
      return sprintf("<span %s>%s</span>", implode(" ", $attributes), lang("Admin/Cloudflare/API/Firewall.label.{$field}"));
      break;
  }
}

//header.php에서 getFieldForm_Helper사용
function getFieldForm_FirewallHelper($field, $value, array $formOptions, array $attributes = array())
{
  $value = is_null($value) ? DEFAULT_EMPTY : $value;
  switch ($field) {
    case 'zone_uid':
      return form_dropdown($field, $formOptions[$field], $value, ['class' => "select-field form-select-sm"]);
      break;
    case 'action':
    case 'filter_paused':
    case 'paused':
      return form_dropdown($field, $formOptions[$field], $value, $attributes);
      break;
    case 'updated_at':
    case 'created_at':
      $attributes["class"] = !array_key_exists("class", $attributes) ? "calender" : $attributes["class"] . " calender";
      return form_input($field, $value, $attributes);
      break;
    default:
      return form_input($field, $value, $attributes);
      break;
  }
} //

function getFieldView_FirewallHelper($field, array $fieldDatas, array $fieldFilters, array $fieldFormOptions, array $attributes = array())
{
  switch ($field) {
    default:
      if (in_array($field, $fieldFilters)) {
        return getFieldForm_FirewallHelper($field, $fieldDatas[$field], $fieldFormOptions, $attributes);
      }
      return $fieldDatas[$field];
      break;
  }
} //

function getFieldIndex_Column_FirewallHelper($field, $order_field, $order_value, array $attributes = array())
{
  $label = lang("Admin/Cloudflare/API/Firewall.label.{$field}");
  $label = $field == $order_field ? sprintf('%s <i class="fa fa-arrow-%s"></i>', $label, $order_value == 'ASC' ? "up" : "down") : $label;
  $order_value = $order_value == 'DESC' ? "ASC" : "DESC";
  return anchor(current_url() . "?order_field={$field}&order_value={$order_value}", $label, $attributes);
} //

function getFieldIndex_Row_FirewallHelper($field, array $row, array $fieldFilters, $fieldFormOptions, $attributes = array(), string $old_zone_uid = ''): string
{
  switch ($field) {
    case 'zone_uid':
      $temp = '';
      if ($old_zone_uid !== $row[$field]) {
        $temp = sprintf(
          '<div style="text-align:left;">%s %s</div>',
          anchor(base_url() . '/admin/cloudflare/zone/firewall/' . $row['zone_uid'], ' ', ["class" => "btn btn-sm btn-primary btn-circle fa fa-refresh", "target" => "_self"]),
          $fieldFormOptions[$field][$row[$field]]
        );
      }
      return $temp;
      break;
    case 'description':
      return sprintf(
        '<button type="button" class="btn btn-secondary" data-toggle="tooltip" data-placement="bottom" title="%s">%s</button>',
        preg_replace('/"/', "'", $row['filter_expression']),
        $row[$field]
      );
      break;
    case 'updated_at':
    case 'created_at':
      return str_split($row[$field], 10)[0];
      break;
    default:
      if (in_array($field, $fieldFilters)) {
        $attributes["onChange"] = sprintf('location.href="%s/toggle/%s/%s?%s="+this.options[this.selectedIndex].value', current_url(), $row['uid'], $field, $field);
        return getFieldForm_FirewallHelper($field, $row[$field], $fieldFormOptions, $attributes);
      }
      return $row[$field];
      break;
  }
} //